
#include "mraa.hpp"
#include "Serial.h"
#include <iostream>
#include <unistd.h>

int main()
{
	// check that we are running on Galileo or Edison
	mraa::Platform platform = mraa::getPlatformType();
	if ((platform != mraa::INTEL_GALILEO_GEN1)
	    && (platform != mraa::INTEL_GALILEO_GEN2)
	    && (platform != mraa::INTEL_EDISON_FAB_C)) {
	  std::cerr << "Unsupported platform, exiting" << std::endl;
	  return mraa::ERROR_INVALID_PLATFORM;
	}

	int e=0;

	//finger object definition
	mraa::Pwm* pwm_pin[]= {new mraa::Pwm(2), new mraa::Pwm(3), new mraa::Pwm(4), new mraa::Pwm(5), new mraa::Pwm(6)};

	for( ; e!=5; ){
		if (pwm_pin[e] == NULL) {
		std::cerr << "Can't create mraa::Pwm object, exiting" << std::endl;

		return mraa::ERROR_UNSPECIFIED;
			}
		e++;
	}

	e=0;

	// enable PWM on the selected pin
	for( ; e!=5; ){
		if (pwm_pin[e]->enable(true) != mraa::SUCCESS) {
			std::cerr << "Cannot enable PWM on mraa::PWM object, exiting" << std::endl;
			return mraa::ERROR_UNSPECIFIED;
		}
		e++;
	}

	e=0;

	//set period and pulse width
	for( ; e!=5; ){
		pwm_pin[e]->period_ms(100);
		pwm_pin[e]->pulsewidth_ms(1);
		e++;
	}

	e=0;

	CSerial serial;
		if (serial.Open(2, 9600)) //set the real COM (2)
			printf("Port opened successfully");
		else{
			printf("Failed to open port!");
			return mraa::ERROR_UNSPECIFIED;
			}

	int fingers[10];

	//cycle
	for(;;){

		/*
		 *
		 *
		 *	third part json parser library
		 *
		 *
		 *
		 *
		 */
	for( ; e!=5; ){

		switch (fingers[e])
		{
		case 0:pwm_pin[e]->pulsewidth_ms(0); break;
		case 1:pwm_pin[e]->write(0.3); break;
		case 2:pwm_pin[e]->write(0.6); break;
		case 3:pwm_pin[e]->write(1); break;
		}
		e++;
	}

	e=0;

	}
	//kill Pwm
	for( ; e!=5; ){
		pwm_pin[e]->~Pwm();
		e++;
	}
	e=0;

	return mraa::SUCCESS;
}
